SystemOrganization addCategory: #'Magritte-Morph-Model'!

!MAElementDescription classSide methodsFor: '*magritte-morph-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClasses
	^ Array with: MATextMorph! !

!MAFileDescription classSide methodsFor: '*magritte-morph-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClasses
	^ Array with: MAFileMorph! !

!MABooleanDescription classSide methodsFor: '*magritte-morph-default' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClasses
	^ Array with: MACheckboxMorph with: MASingleSelectListMorph! !

!MAMultipleOptionDescription classSide methodsFor: '*magritte-morph-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClasses
	^ Array with: MAMultiSelectListMorph! !

!GRPackage classSide methodsFor: '*magritte-morph' stamp: 'lr 2/18/2010 10:30'!
magritteMorph
	^ self new
		name: 'Magritte-Morph';
		description: 'Morphic integration for the Magritte metamodel.';
		addDependency: 'Magritte-Model';
		url: #magritteUrl;
		yourself! !

Model subclass: #MADescriptionMorph
	instanceVariableNames: 'memento description parent morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

MADescriptionMorph subclass: #MAContainerMorph
	instanceVariableNames: 'children answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAContainerMorph methodsFor: 'decorating' stamp: 'lr 3/9/2006 11:33'!
addButtons
	self addButtons: #( save cancel )! !

!MAContainerMorph methodsFor: 'decorating' stamp: 'lr 10/30/2006 13:41'!
addButtons: anArray
	morph := self rectangleMorph
		addMorphBack: self morph;
		addMorphBack: (self barMorph: anArray);
		yourself! !

!MAContainerMorph methodsFor: 'decorating' stamp: 'TudorGirba 5/7/2011 23:29'!
addWindow
	| scrollPane newMorph |
	scrollPane := GeneralScrollPane new.
	newMorph := self morph 
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	scrollPane changeScrollerTableLayout; scrollTarget: newMorph.	


	morph := self windowMorph
		model: self;
		vResizing: #shrinkWrap;
		addMorph: (scrollPane layoutInset: 5 @ 5)
			frame: (0 @ 0 corner: 1 @ 1);
		yourself! !

!MAContainerMorph methodsFor: 'answering' stamp: 'lr 6/17/2010 09:39'!
answer: anObject
	answer isNil
		ifFalse: [ answer value: anObject ].
	self morph delete! !

!MAContainerMorph methodsFor: 'private' stamp: 'NickAger 1/17/2012 15:57'!
buildChildren
	^ Array streamContents: [ :stream |
		self magritteDescription do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (each morphClass
					memento: self memento
					description: each
					parent: self) ] ] ]! !

!MAContainerMorph methodsFor: 'private' stamp: 'NickAger 1/17/2012 15:57'!
buildMorphView
	| result |
	result := self rectangleMorph
		setBalloonText: self magritteDescription comment;
		listDirection: #topToBottom;
		cellInset: 3;
		yourself.
	self children do: [ :each |
		result addMorphBack: each morph ].
	^ result! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 3/9/2006 11:33'!
callInHand
	| result |
	result := nil.
	self onAnswer: [ :value | result := value ].
	self openInHand; waitUntilClosed.
	^ result! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 3/9/2006 11:33'!
callInWorld
	| result |
	result := nil.
	self onAnswer: [ :value | result := value ].
	self openInWorld; waitUntilClosed.
	^ result! !

!MAContainerMorph methodsFor: 'actions' stamp: 'lr 4/5/2007 17:12'!
cancel
	self reset; answer: nil! !

!MAContainerMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
children
	^ children! !

!MAContainerMorph methodsFor: 'answering' stamp: 'lr 3/9/2006 11:33'!
onAnswer: aBlock
	answer := aBlock! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 3/9/2006 11:33'!
openInHand
	^ self morph openInHand! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 3/9/2006 11:33'!
openInWorld
	^ self morph openInWorld! !

!MAContainerMorph methodsFor: 'actions' stamp: 'jf 10/28/2009 15:28'!
save
	[ self validate ]
		on: MAValidationError
		do: [ :err | ^ self inform: err greaseString ].
	self commit; answer: self model! !

!MAContainerMorph methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setChildren: aCollection
	children := aCollection! !

!MAContainerMorph methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setDescription: aDescription
	super setDescription: aDescription.
	self setChildren: self buildChildren! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'TudorGirba 5/7/2011 23:34'!
waitUntilClosed
	[ self morph world notNil ]
		whileTrue: [ self morph outermostWorldMorph doOneCycle ]! !

MAContainerMorph subclass: #MASilentContainerMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MASilentContainerMorph commentStamp: 'tg 5/6/2009 13:26' prior: 0!
The only difference to the superclass is that on answer it does not delete the morph. This is useful when we want the morph to be embedded.!

!MASilentContainerMorph methodsFor: 'answering' stamp: 'lr 6/17/2010 09:41'!
answer: anObject
	answer isNil
		ifFalse: [ answer value: anObject ].! !

!MADescriptionMorph classSide methodsFor: 'instance creation' stamp: 'NickAger 1/19/2012 17:00'!
memento: aMemento
	^ self memento: aMemento description: aMemento magritteDescription! !

!MADescriptionMorph classSide methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:33'!
memento: aMemento description: aDescription
	^ self memento: aMemento description: aDescription parent: nil! !

!MADescriptionMorph classSide methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:33'!
memento: aMemento description: aDescription parent: aComponent
	^ self new
		setMemento: aMemento;
		setDescription: aDescription;
		setParent: aComponent;
		yourself! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 3/9/2006 11:33'!
barMorph: anArray
	| bar |
	bar := self rectangleMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		listDirection: #leftToRight;
		listCentering: #center;
		wrapCentering: #bottomRight;
		cellInset: self defaultSpacerSize;
		yourself.
	anArray do: [ :selector |
		bar addMorphBack: (self buttonMorph: selector) ].
	^ bar! !

!MADescriptionMorph methodsFor: 'private' stamp: 'NickAger 1/17/2012 15:56'!
buildMorph
	^ self magritteDescription isReadonly
		ifTrue: [ self buildMorphView ]
		ifFalse: [ self buildMorphEditor ]! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildMorphEditor
	^ self buildMorphView! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildMorphView
	self subclassResponsibility! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 2/21/2008 11:33'!
buttonMorph: aSelector
	| button |
	button := PluggableButtonMorph
		on: self
		getState: #buttonState
		action: aSelector.
	button
		label: aSelector;
		hResizing: #spaceFill;
		shortcutCharacter: aSelector first.
	^ button! !

!MADescriptionMorph methodsFor: 'private-morphic' stamp: 'lr 3/9/2006 11:33'!
buttonState
	^ true! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
commit
	self memento commit! !

!MADescriptionMorph methodsFor: 'accessing-configuration' stamp: 'NickAger 1/17/2012 15:56'!
defaultBackgroundColor
	^ self magritteDescription morphColor! !

!MADescriptionMorph methodsFor: 'accessing-configuration' stamp: 'lr 3/9/2006 11:33'!
defaultSpacerSize
	^ 5! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'NickAger 1/17/2012 15:56'!
magritteDescription
	^ description! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
memento
	^ memento! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
model
	^ self memento model! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
morph
	^ morph ifNil: [ morph := self buildMorph ]! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
parent
	^ parent! !

!MADescriptionMorph methodsFor: 'private-morphic' stamp: 'lr 3/9/2006 11:33'!
perform: selector orSendTo: otherTarget
	^ (self respondsTo: selector)
		ifTrue: [ self perform: selector ]
		ifFalse: [ otherTarget perform: selector ]! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 3/9/2006 11:33'!
rectangleMorph
	^ RectangleMorph new
		borderWidth: 0;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellPositioning: #topLeft;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		yourself! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
reset
	self memento reset! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
root
	^ self parent isNil
		ifTrue: [ self ]
		ifFalse: [ self parent root ]! !

!MADescriptionMorph methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setDescription: aDescription
	description := aDescription! !

!MADescriptionMorph methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setMemento: aMemento
	memento := aMemento! !

!MADescriptionMorph methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:33'!
setParent: aMorph
	parent := aMorph! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 3/9/2006 11:33'!
stringMorph
	^ StringMorph new! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
validate
	"Flushes the cached state of some morphic elements (such as text-morphs) to the memento and then does the validation. I don't know of a better flush the morphic contents (happy flickering), probably morphic is just too limited to customize that easily or I am too dumb to find out."

	self morph allMorphsDo: [ :each |
		(each respondsTo: #accept)
			ifTrue: [ each accept ] ].
	self memento validate! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'NickAger 1/19/2012 17:00'!
windowMorph
	^ SystemWindow labelled: self magritteDescription label! !

MADescriptionMorph subclass: #MAElementMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

MAElementMorph subclass: #MACheckboxMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MACheckboxMorph methodsFor: 'private' stamp: 'NickAger 1/17/2012 15:58'!
buildMorphEditor
	^ UITheme current 
		newCheckboxIn: nil
		for: self
		getSelected: #selected
		setSelected: #selected:
		getEnabled: #enabled
		label: self magritteDescription label 
		help: self magritteDescription comment! !

!MACheckboxMorph methodsFor: 'actions' stamp: 'tg 5/14/2009 22:03'!
enabled
	^ true! !

!MACheckboxMorph methodsFor: 'actions' stamp: 'NickAger 1/17/2012 15:58'!
selected
	^ (self value ifNil: [ self magritteDescription default ]) ifNil: [ false ]! !

!MACheckboxMorph methodsFor: 'actions' stamp: 'tg 5/14/2009 22:03'!
selected: aBoolean
	self value: aBoolean ! !

!MAElementMorph methodsFor: 'private' stamp: 'NickAger 1/17/2012 15:58'!
buildMorph
	| result |
	result := self rectangleMorph
		layoutInset: 1 @ 1;
		listDirection: #leftToRight;
		addMorphBack: self buildMorphLabel;
		addMorphBack: super buildMorph;
		yourself.
	self magritteDescription hasComment
		ifTrue: [ result setBalloonText: self magritteDescription comment ].
	self magritteDescription isRequired
		ifTrue: [ result addMorphBack: self buildMorphRequired ].
	^ result! !

!MAElementMorph methodsFor: 'private' stamp: 'NickAger 1/17/2012 15:58'!
buildMorphLabel
	^ self stringMorph
		contents: self magritteDescription label , ':';
		width: 100;
		yourself! !

!MAElementMorph methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildMorphRequired
	^ self stringMorph
		contents: ' *';
		color: Color red;
		yourself! !

!MAElementMorph methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildMorphView
	^ self stringMorph
		contents: self string;
		yourself! !

!MAElementMorph methodsFor: 'accessing' stamp: 'NickAger 1/17/2012 15:58'!
string
	^ self magritteDescription toString: self value! !

!MAElementMorph methodsFor: 'accessing' stamp: 'NickAger 1/17/2012 15:58'!
string: aString
	| value |
	value := [ self magritteDescription fromString: aString greaseString ]
		on: Error do: [ :e | aString ].
	self value: value; changed: #string! !

!MAElementMorph methodsFor: 'accessing' stamp: 'NickAger 1/17/2012 15:58'!
value
	^ self memento readUsing: self magritteDescription! !

!MAElementMorph methodsFor: 'accessing' stamp: 'NickAger 1/17/2012 15:58'!
value: anObject
	self memento write: anObject using: self magritteDescription.
	self changed: #value! !

MAElementMorph subclass: #MAFileMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAFileMorph methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildMorphEditor
	^ self buttonMorph: #choose! !

!MAFileMorph methodsFor: 'actions' stamp: 'NickAger 1/17/2012 15:59'!
choose
	| name stream |
	name := UIManager default
		chooseFileMatching: nil 
		label: 'Choose ' , self magritteDescription label.
	stream := FileStream readOnlyFileNamed: name.
	stream isNil ifTrue: [ ^ self ].
	stream binary.
	self value: (self magritteDescription kind new
		contents: stream contents;
		filename: stream localName;
		yourself).
	stream close! !

MAElementMorph subclass: #MAListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAListMorph methodsFor: 'accessing-dynamic' stamp: 'NickAger 1/17/2012 15:59'!
options
	^ self magritteDescription allOptions! !

!MAListMorph methodsFor: 'accessing-dynamic' stamp: 'NickAger 1/17/2012 15:59'!
strings
	^ self options collect: [ :each | self magritteDescription reference toString: each ]! !

MAListMorph subclass: #MAMultiSelectListMorph
	instanceVariableNames: 'selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAMultiSelectListMorph methodsFor: 'private' stamp: 'EstebanLorenzano 12/11/2011 11:41'!
buildMorphEditor
	^ (PluggableListMorph on: self list: #strings primarySelection: #selected changePrimarySelection: #selected: listSelection: #selectionAt: changeListSelection: #selectionAt:put: menu: nil)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 1;
		beMultipleSelection;
		yourself! !

!MAMultiSelectListMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
selected
	^ selected ifNil: [ selected := 0 ]! !

!MAMultiSelectListMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
selected: anInteger
	selected := anInteger.
	self changed: #selected! !

!MAMultiSelectListMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
selectionAt: anInteger
	^ self value includes: (self options at: anInteger)! !

!MAMultiSelectListMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
selectionAt: anInteger put: aBoolean
	| option |
	option := self options at: anInteger.
	self value: (aBoolean
		ifTrue: [ self value copyWith: option ]
		ifFalse: [ self value copyWithout: option ]).
	self changed: #selected! !

MAListMorph subclass: #MASingleSelectListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MASingleSelectListMorph methodsFor: 'private' stamp: 'lr 10/30/2006 13:43'!
buildMorphEditor
	^ (PluggableListMorph on: self list: #strings selected: #selected changeSelected: #selected:)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 1;
		yourself! !

!MASingleSelectListMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
selected
	^ self options indexOf: self value! !

!MASingleSelectListMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
selected: anInteger
	self value: (self options at: anInteger ifAbsent: [ nil ]).
	self changed: #selected! !

MAElementMorph subclass: #MAMemoMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAMemoMorph methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
annotation
	^ self string! !

!MAMemoMorph methodsFor: 'private' stamp: 'tg 10/19/2007 11:12'!
buildMorphEditor
	"The selector #annotation should be #string instead, but we use this one and dispatch since this prevents morphic to draw a thin red border around changed fields. Stupid hack, really, but doesn't work otherwise."

	^ (PluggableTextMorph on: self text: #annotation accept: #string:)
		height: 400;
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 1;
		yourself! !

!MAMemoMorph methodsFor: 'accessing' stamp: 'tg 5/15/2009 00:03'!
enabled
	^ true! !

!MAMemoMorph methodsFor: 'accessing' stamp: 'NickAger 1/17/2012 15:59'!
selected
	^ (self value ifNil: [ self magritteDescription default ]) ifNil: [ false ]! !

!MAMemoMorph methodsFor: 'accessing' stamp: 'tg 5/15/2009 00:03'!
selected: aBoolean
	self value: aBoolean ! !

MAMemoMorph subclass: #MATextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

MATextMorph subclass: #MAPasswordMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Model'!

!MAPasswordMorph methodsFor: 'private' stamp: 'lr 3/9/2006 11:33'!
buildMorphEditor
	^ super buildMorphEditor
		font: (StrikeFont passwordFontSize: 12);
		yourself! !

!MATextMorph methodsFor: 'private' stamp: 'NickAger 1/17/2012 15:59'!
buildMorphEditor
	^ UITheme current 
		newTextEntryIn: nil 
		for: self  
		get: #string  
		set: #string: 
		class: String
		getEnabled: #enabled 
		help: self magritteDescription comment! !

!MAPasswordDescription classSide methodsFor: '*magritte-morph-default' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClasses
	^ Array with: MAPasswordMorph! !

!MAMemoDescription classSide methodsFor: '*magritte-morph-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClasses
	^ Array with: MAMemoMorph! !

!MASingleOptionDescription classSide methodsFor: '*magritte-morph-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClasses
	^ Array with: MASingleSelectListMorph! !

!MAContainer classSide methodsFor: '*magritte-morph-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClasses
	^ Array with: MAContainerMorph! !

!MAContainer methodsFor: '*magritte-morph-converting' stamp: 'lr 3/9/2006 11:33'!
asMorphOn: anObject
	^ self morphClass
		memento: (anObject mementoClass
			model: anObject
			description: self)! !

!Object methodsFor: '*magritte-morph-converting' stamp: 'EstebanLorenzano 1/4/2012 15:48'!
asMorph
	^ self magritteDescription asMorphOn: self! !

!MADescription classSide methodsFor: '*magritte-morph-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClass
	^ self defaultMorphClasses notEmpty
		ifTrue: [ self defaultMorphClasses first ]! !

!MADescription classSide methodsFor: '*magritte-morph-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultMorphClasses
	^ Array new! !

!MADescription classSide methodsFor: '*magritte-morph-defaults' stamp: 'lr 2/21/2008 11:36'!
defaultMorphColor
	^ Color white! !

!MADescription methodsFor: '*magritte-morph-accessing' stamp: 'NickAger 1/16/2012 18:12'!
descriptionMorphClass
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #morphClass;
		label: 'Morph Class';
		priority: 2000;
		reference: MAClassDescription new;
		options: self class defaultMorphClasses;
		default: self class defaultMorphClass;
		yourself! !

!MADescription methodsFor: '*magritte-morph-accessing' stamp: 'lr 3/9/2006 11:33'!
morphClass
	^ self propertyAt: #morphClass ifAbsent: [ self class defaultMorphClass ]! !

!MADescription methodsFor: '*magritte-morph-accessing' stamp: 'lr 3/9/2006 11:33'!
morphClass: aClass
	^ self propertyAt: #morphClass put: aClass! !

!MADescription methodsFor: '*magritte-morph-accessing' stamp: 'lr 3/9/2006 11:33'!
morphColor
	^ self propertyAt: #morphColor ifAbsent: [ self class defaultMorphColor ]! !

!MADescription methodsFor: '*magritte-morph-accessing' stamp: 'lr 3/9/2006 11:33'!
morphColor: aColor
	^ self propertyAt: #morphColor put: aColor! !
